/* ------------------------------------------------------------ */
/*                                                              */
/* Header file for KeyLocks II Server API.                      */
/*                                                              */
/* (c) Copyright 1992 Yankee Software, All rights reserved.     */
/*                                                              */
/* ------------------------------------------------------------ */

// This files assumes the following definitions are known

// #define EXTERNAL     extern
// #define FUNCTION
// #define USHORT       unsigned short int   /* 16 bits */
// #define INT          short int            /* 16 bits */
// #define VOID         void

// Functions in KEYLOCK.DLL for public clients

EXTERNAL FUNCTION USHORT pascal far KeyLockSet(INT numlock_state, INT capslock_state, 
      INT scrolllock_state);
EXTERNAL FUNCTION USHORT pascal far KeyLockQStable(VOID);
EXTERNAL FUNCTION USHORT pascal far KeyLockTidyUp(VOID);

// Starting point for DLL's errors

#define     KL_ERROR_BASE              50000

// Errors that indicate the user's situation is not kosher

#define     KL_ERROR_ALREADY_INIT      KL_ERROR_BASE + 1
#define     KL_ERROR_SESSION           KL_ERROR_BASE + 2
#define     KL_ERROR_NO_INIT           KL_ERROR_BASE + 3

// Errors that indicates that DLL or OS/2 is messed up

#define     KL_ERROR_SYSTEM            KL_ERROR_BASE + 4
#define     KL_ERROR_BROKEN            KL_ERROR_BASE + 5

// Errors that indicate a lack of resources

#define     KL_ERROR_SEM               KL_ERROR_BASE + 6
#define     KL_ERROR_HANDLES           KL_ERROR_BASE + 7
#define     KL_ERROR_TIMEOUT           KL_ERROR_BASE + 8

// Values returned by KeyLockQStable()

#define KL_STABLE       0
#define KL_UNSTABLE     1
#define KL_BROKEN       2




